; Elicoph
; 1KB minigame
; by Stefano Tognon
; (C) 2002 Ice Team
; version 1.00

; Well, I like this competition even this year!!!
; This is my 4 game for C64

; Game concept:
;
; Fly away and destroy the enemy, or die!
;
; The game is quite linear and simple for having the music in it!
; it is used the Minima music routine and Lazy Jones tune 21 as sound track.


      processor 6502
      org 3840


; sprite of sx to dx elicopter.
; the main color is for explosion effect!
  .byte 0, 0, 0, 0, 0, 0, 0, 0, 0
  .byte 2, 63, 255, 2, 128, 64, 0, 160, 66
  .byte 138, 43, 242, 138, 13, 92, 48, 53, 139
  .byte 220, 53, 35, 223, 245, 163, 48, 13, 87
  .byte 136, 43, 252, 138, 161, 18, 2, 133, 86
  .byte 2, 0, 136, 0, 0, 162, 0, 2, 162
  .byte 0, 0, 0, 0, 0, 0, 0, 0, 0, 0

; fire sprite
  .byte 0, 0, 0, 0, 0, 0, 0, 0, 0
  .byte 0, 0, 0, 0, 0, 0, 0, 0, 0
  .byte 0, 0, 4, 0, 0, 14, 0, 2, 27
  .byte 0, 7, 14, 0, 13, 132, 0, 7, 0
  .byte 0, 2, 0, 0, 0, 0, 0, 0, 0
  .byte 0, 0, 0, 0, 0, 0, 0, 0, 0
  .byte 0, 0, 0, 0, 0, 0, 0, 0, 0, 0

; laser sprite
  .byte 0, 0, 0, 0, 0, 0, 0, 0, 0
  .byte 0, 0, 0, 0, 0, 0, 0, 0, 0
  .byte 0, 0, 0, 0, 0, 0, 0, 0, 0
  .byte 0, 0, 0, 0, 0, 0, 0, 0, 0
  .byte 0, 0, 0, 85, 85, 85, 0, 0, 0
  .byte 0, 0, 0, 85, 85, 85, 0, 0, 0
  .byte 0, 0, 0, 0, 0, 0, 0, 0, 0, 0

; ufo sprite
  .byte 0, 0, 0, 0, 0, 0, 0, 0, 0
  .byte 2, 0, 128, 32, 130, 8, 40, 40, 40
  .byte 10, 20, 160, 2, 105, 128, 33, 130, 64
  .byte 41, 40, 104, 1, 0, 64, 5, 85, 82
  .byte 39, 255, 216, 159, 255, 244, 31, 255, 244
  .byte 127, 255, 253, 85, 85, 85, 34, 0, 136
  .byte 128, 130, 2, 0, 0, 0, 0, 0, 0, 0

  org 4096

SCREEN     = $E544    ; clean the screen
GETIN      = $FFE4    ; get a char from the keyboard
SET_COOR   = $E50C    ; set x/y coord
PUT_CHAR   = $E716    ; put a char in the screen
LINE       = $E9F0    ; calculate current line address
STRING     = $AB1E    ; put a string
KSCAN      = $FF9F    ; keyboard scan
GETIN      = $FFE4    ; get char

TEMP       = $A9      ; temp var
ULIVE      = $B2      ; lives of the ufo
FIRE       = $8E      ; <>0 if we are firing
MOV        = $8D      ; 0=stopped 1=up 2=dn 3=sx 4=dx
ELIVE      = $9D      ; elicoph lives
GO         = $A5      ; 1=go interrupt
UFIRE      = $A6      ; 1=ufo is firing

VEL        = 4        ; velocity of the movement

S0X        = 53248    ; elicoph x
S0Y        = 53248+1  ; elicoph y
S1X        = 53248+2  ; bomb x
S1Y        = 53248+3  ; bomb y
S2X        = 53248+4  ; laser x
S2Y        = 53248+5  ; laser y
S3X        = 53248+6  ; ufo x
S3Y        = 53248+7  ; ufo y

RANDOM     = 54272+27 ; random number from osc 3
COLLIS     = 53248+30 ; collision

RASTER0 = 30

MAX_UP = 55       ; max up position of ufo
MAX_DN = 225      ; max dn position of ufo
MAX_SX = 90       ; max sx position of ufo
MAX_DX = 245      ; max dx position of ufo

      jsr  InitFreq
      lda  #00
      sta  GO
      jsr  Reset

   lda  #$ff
   sta  $d416
   lda  #$03
   sta  $d417

      lda  #$66                        ; init AD
      sta  54272+5
      sta  54272+12

      ;lda  #255
      ;sta  54272+2
      ;sta  54272+9

initraster:
      sei
      lda  #<raster0
      sta  $0314
      lda  #>raster0
      sta  $0315
      lda  #RASTER0                    ;Set low bits of raster
      sta  $d012                       ;position
      ;lda  $d011
      ;and  #$7f                        ;Set high bit of raster
      ;sta  $d011                       ;position (0)
      lda  #$7f                        ;Set timer interrupt off
      sta  $dc0d

      lda  #$01                        ;Set raster interrupt on
      sta  $d01a
      lda  $dc0d                       ;Acknowledge timer interrupt
      cli


      ; init random number generator
      lda  #129
      sta  54272+18
      sta  54272+14
      sta  54273+14

      ; init screen
      lda  #1
      sta  53281
      sta  53248+42            ; color sprite 3
      jsr  SCREEN

      ; init sprite common color

      lda  #0
      sta  53248+37            ; common sprite color 1
      sta  53248+40            ; color sprite 1
      sta  53248+41            ; color sprite 2
      sta  FIRE

      lda  #5
      sta  53248+38            ; common sprite color 2

      lda  #9
      sta  53248+28            ; select multicolor sprite

      ; init sprite pointers
      ldx  #60
      stx  2040
      inx
      stx  2041
      inx
      stx  2042
      inx
      stx  2043

main:
      lda  #3
      sta  ELIVE              ; 3 lives for the elicoph

      lda  #$9
      ora  53248+21           ; make the sprites visible
      sta  53248+21
      sta  ULIVE              ; 9 lives for the ufo
      lda  #40
      sta  S0X                ; elicoph pos x
      lda  #100
      sta  S0Y                ; elicoph pos y

      lda  #60                ; ufo position
      sta  S3Y
      lda  #200
      sta  S3X
main2:
      jsr  KSCAN
      jsr  GETIN
      cmp  #0
      beq  main2

      inc  GO                 ; game start

repeat:
      lda  GO
      bne  repeat
      jmp  main


goUp:                      ; go up if not in top of the window
      lda  S0Y             ; elicoph y pos
      cmp  #50
      bcc  endJoy

      sbc  #VEL
      sta  S0Y             ; elicoph y pos
      bne  endJoy

goDn:                      ; go dn if not in bottom of the window

      lda  S0Y             ; elicoph y pos
      cmp  #229
      bcs  endJoy

      adc  #VEL
      sta  S0Y             ; elicoph y pos
      bne  endJoy

goFire:

      lda  FIRE
      bne  cont

      lda  S0Y              ; set y coord
      sta  S1Y              ; of bomb

      lda  S0X              ; set x coord
      adc  #8
      sta  S1X              ; of bomb

      lda  #2               ; sprite is visible
      ora  53248+21
      sta  53248+21

      inc  FIRE           ; remember we are firing
      bne  cont

endJoy:
      jmp  afterJoy

raster0:
      inc  $d019
      lda  #0
      jsr  Play

      lda  GO
      bne  execute
      jmp  $ea81

execute:
      lda  #1                 ; make the explosion not visible if it was
      sta  53248+39
      sta  53248+42

      ;lda  #<raster0
      ;sta  $0314
      ;lda  #>raster0
      ;sta  $0315

      ;lda  #RASTER0                    ;Set low bits of raster
      ;sta  $d012                       ;position
      ;lda  $d011
      ;and  #$7f                        ;Set high bit of raster
      ;sta  $d011                       ;position (0)

      ; look for direction
      lda  $DC01
      eor  #$FF
      sta  TEMP

      lda  #$10
      bit  TEMP
      bne  goFire

cont:
      lda  #$01                   ; test for up
      bit  TEMP
      bne  goUp
notUp:
      asl                         ; test for dn
      bit  TEMP
      bne  goDn
notDn:

afterJoy:

      ; if FIRE is on, make fire animation
      lda  FIRE
      beq  afterFire

      lda  S1X                 ; bomb pos x
      adc  #VEL                ; add for new pos
      sta  S1X                 ; bomb pos x
      bcc  afterFire

      jsr  decFire

afterFire:

      ; if UFIRE is on, make ufo fire animation on
      lda  UFIRE
      beq  afterUFire

      lda  S2X                 ; laser pos x
      sbc  #VEL                ; dec for new pos
      sta  S2X                 ; laser pos x
      bcs  afterUFire

      jsr  decUfire

afterUFire:

      ; laser fire for the ufo

      lda  UFIRE
      bne  ufoMov

      lda  S3X                 ; copy ufo position
      sta  S2X
      lda  S3Y
      sta  S2Y

      inc  UFIRE               ; ufo is firing

      lda  #04
      ora  53248+21
      sta  53248+21

ufoMov:
      ; now move the ufo according to the MOV flag

      lda  MOV                 ; mov flag
    ;;;  beq  endMov

      cmp  #1                  ; is up
      bne  next1

      lda  S3Y                 ; ufo pos y
      cmp  #MAX_UP
      bcc  movRandom

      sbc  #VEL                ; dec ufo pos y (go up)
      sta  S3Y

      lda  RANDOM
      cmp  #5                  ; make the movemente a bit more random
      bcs  endMov
      bcc  movRandom

next1:
      cmp  #2                  ; is dn
      bne  next2

      lda  S3Y                 ; ufo pos y
      cmp  #MAX_DN
      bcs  movRandom

      adc  #VEL                ; inc ufo pos y (go dn)
      sta  S3Y
      ;bne  endMov

      lda  RANDOM
      cmp  #5                  ; make the movement a bit more random
      bcs  endMov
      bcc  movRandom

next2:
      cmp  #3
      bne  next3

      lda  S3X                 ; ufo x pos
      cmp  #MAX_SX
      bcc  movRandom

      sbc  #VEL                ; dec ufo pos x (go sx)
      sta  S3X

      lda  RANDOM
      cmp  #5                  ; make the movement a bit more random
      bcs  endMov
      bcc  movRandom
      ;bne  endMov

next3:
      lda  S3X                 ; ufo pos x
      cmp  #MAX_DX
      bcs  movRandom

      adc  #VEL                ; add ufo pos x (go dx)
      sta  S3X
      ;bne  endMov


endMov:
      ; check collision

      lda  COLLIS
      sta  TEMP
      and  #$01
      bne  elicKO

checkUfo:
      lda  TEMP
      and  #$0a
      cmp  #$0a
      beq  ufoKO

exit:
      jmp  $ea81


      ; select a random movement for the ufo
movRandom:
      lda  RANDOM
      and  #$0F
      sta  MOV
      jmp  endMov

elicKO:
      lda  #2                   ; make the explosion visible
      sta  53248+39
      jsr  decUfire

      dec  ELIVE                ; decrement elicoph lives
      beq  over
      jmp  checkUfo

ufoKO:
      lda  #2                   ; make the explosion visible
      sta  53248+42
      jsr  decFire

      dec  ULIVE                ; decrement ufo lives
      bne  skipOver
over:
      dec  GO                   ; game finish
skipOver:
      jmp  exit



decFire:
      lda  #0
      sta  FIRE

      lda  #$fd                ; make sprite not visible
      and  53248+21
      sta  53248+21
      rts

decUfire:
      lda  #0
      sta  UFIRE

      lda  #$fb                ; make sprite not visible
      and  53248+21
      sta  53248+21
      rts






ARPDEL   = 2
SR       = 00;$c9


curtune  = $fe
CURDUR   = $09

tunepos  = $b0            ;position in note sequence
dur      = $b4            ;2 bytes each
notefx   = $b6
curnote  = $b8
newnote  = $ba

arpdur   = $bc
arpoff   = $bd

noteptr  = $fa
temp     = $fa
freqtab  = $c000




start

InitFreq:
         ldy #192
l2:      ldx #24
loop:    lda freq-1,x
         sta freqtab-1,y
         dex
         dey
         lda freq-1,x
         sta freqtab-1,y
         lsr freq,x
         ror freq-1,x
         dey
         beq xit
         dex
         bne loop
         beq l2
xit:     rts


Reset:                    ; Force a tune reset
         sec
         ror curtune
                          ; ldx #255
                          ; stx curtune
Play
         ldx #1
         cmp curtune
         beq PlayTune
         sta curtune

         ldy #00
         sty tunepos
                          ;         sty tunepos+1
         sty dur
         sty dur+1

         lda #$1f ;0f
         sta $d418
         lda #SR
         sta $d406
         sta $d406+7

SetTune:
         ldy curtune
         txa
         beq v1
v2:      lda v2tunepos,y
         bne sta_
v1:      lda v1tunepos,y
sta_:    sta tunepos,x


PlayTune:

Get:
         lda #00
         sta newnote,x
         dec dur,x
         bpl DoFx

next:    ldy tunepos,x
         inc tunepos,x
         lda tunes,y
         beq SetTune

note:                    ;sta curnote,x
                         ;sta newnote,x
                         ;jsr setfreq
setfreq:
         asl
         tay
         lda freqtab,y
         pha
         lda freqtab+1,y
         ldy SidOffset,x
         sta $d401,y
         pla
         sta $d400,y
gate:

         lda #$20
         ldy SidOffset,x
         sta $d404,y
         lda #$21
         sta $d404,y

hold:    lda #CURDUR
         sta dur,x

DoFx:
         dex
         bpl PlayTune
RTS:     rts


freq:
         .word 34334
         .word 36377
         .word 38539
         .word 40831
         .word 43258
         .word 45831
         .word 48557
         .word 51444
         .word 54502
         .word 57743
         .word 61177
         .word 64815

                          ;arptab .byte 0,4,7

v1tunepos
         .byte t0v1-tunes

v2tunepos
         .byte t0v2-tunes

tunes
           ;.byte 00           ;dummy byte

SidOffset
         .byte 00
         .byte 07

t0v1:
         ;.byte 97
         .byte 23+1,35+1,23+1,35+1
         .byte 23+1,35+1,23+1,35+1
         .byte 23+1,35+1,23+1,35+1
         .byte 23+1,35+1,23+1,35+1
         .byte 28+1,40+1,28+1,40+1
         .byte 30+1,42+1,30+1,42+1
         .byte 23+1,35+1,23+1,35+1
         .byte 23+1,35+1,23+1,35+1
         .byte 00

t0v2:
         ;.byte 97
         .byte 24+1,47+1,50+1,52+1
         .byte 54+1,36+1,24+1,36+1
         .byte 24+1,47+1,50+1,52+1
         .byte 54+1,55+1,54+1,50+1
         .byte 52+1,40+1,29+1,40+1
         .byte 50+1,42+1,54+1,47+1
         .byte 24+1,36+1,24+1,36+1
         .byte 24+1,36+1,24+1,36+1
         .byte 00



